package cn.efunbox.audio.clients;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

import java.util.HashMap;
import java.util.Map;

/**
 * Created by yao on 17-10-25.
 */
@Service
public class UserHttp {

    @Value("${iaas.user.register}")
    private  String urlRegister;
    @Value("${iaas.user.audio.bizCode}")
    private String bizCode;
    @Value("${iaas.user.audio.appCode}")
    private String appCode;
    @Value("${iaas.user.audio.platform}")
    private String platform;
    @Value("${iaas.user.audio.os}")
    private String os;
    @Value("${iaas.user.audio.appVer}")
    private String appVer;
    @Value("${iaas.user.audio.terminal}")
    private String terminal;
    @Value("${iaas.user.audio.entryType}")
    private String entryType;

    public String Register(String requestId, String dist, String userIp, String idDeivce, String passwd) {
        HttpHeaders requestHeaders = new HttpHeaders();
        requestHeaders.setContentType(MediaType.APPLICATION_JSON);
        requestHeaders.add("bizCode", bizCode);
        requestHeaders.add("requestId", requestId);
        requestHeaders.add("appCode", appCode);
        requestHeaders.add("platform", platform);
        requestHeaders.add("os", os);
        requestHeaders.add("dist", dist);
        requestHeaders.add("userIp", userIp);
        requestHeaders.add("appVer", appVer);
        requestHeaders.add("terminal", terminal);

        Map<String, String> map = new HashMap<String, String>();
        map.put("entry", idDeivce);
        map.put("entryType", entryType);
        map.put("passwd", passwd);
        map.put("avatar", "");
        map.put("nickname", "");

//        System.out.println("header:");
//        System.out.println(requestHeaders.toString());
//        System.out.println("body:");
//        System.out.println(map.toString());
//        System.out.println("url:");
//        System.out.println(urlRegister);

        RestTemplate restTemplate = new RestTemplate();
        return restTemplate.postForEntity(urlRegister, new HttpEntity<Map>(map, requestHeaders), String.class).getBody();
    }

}
