package cn.efunbox.audio.entity;


import lombok.Data;
import lombok.ToString;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;
import java.math.BigInteger;
import java.sql.Timestamp;

/**
 * 音视频资源
 * Created by yao on 17-9-26.
 */


@Data
@ToString
@Entity
@DynamicInsert
@DynamicUpdate
public class Audio implements Serializable, Cloneable {

    @Id
    @GeneratedValue
    @Column(name = "id")
    private Long id;

    @Column
    private Integer mediaType;

    //资源组编号
    @Column
    private Long idGroup;

    //专辑下的第几集
    @Column
    private Integer lesson;

    //所属年级
    @Column
    private String grade;

    //适用最小年龄
    @Column
    private Integer ageMin;

    //适用最大年龄
    @Column
    private Integer ageMax;

    //音频名称，如两只老虎
    @Column
    private String name;

    //关键词，如老虎
    @Column
    private String keyword;

    //来自资源平台的id
    @Column
    private String idResource;

    //播放地址
    @Column
    private String url;

    @Column
    private Integer status;


    @Column(name = "total_time")
    private Long totalTime;

    @Column
//    @Temporal(TemporalType.TIMESTAMP)
//    private Date created;
    private Timestamp created;

    private Timestamp modified;

    @Column(name = "album_id")
    private BigInteger albumId;

    private String author;
    //专辑名，如儿歌
    @Transient
    private String album;
    @Transient
    private String albumImage="";
    @Transient
    private String productPackage="";

    public Object clone() throws CloneNotSupportedException {
        return super.clone();
    }


}
