package cn.efunbox.audio.impl;

import cn.efunbox.audio.entity.Audio;
import cn.efunbox.audio.entity.Channel;
import cn.efunbox.audio.repository.AudioRepo;
import cn.efunbox.audio.repository.ChannelRepo;
import cn.efunbox.audio.service.AudioService;
import cn.efunbox.audio.service.ChannelService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by yao on 17-9-26.
 */
@Service
public class ChannelServiceImpl implements ChannelService {

    @Autowired
    ChannelRepo channelRepo;

    @Override
    public Channel GetOne(Long id){
        Channel channel = channelRepo.findOne(id);
        return channel;
    }

    @Override
    public Page<Channel> SearchAll(int page, int size){
        if(size<=0)
            size = 50;
        Pageable pageable = new PageRequest(page, size);
        Page<Channel> list = channelRepo.findAll(pageable);
        return list;
    }

    @Override
    public List<Channel> SearchById(Long id){
        List<Channel> list = channelRepo.findById(id);
        return list;
    }

    @Override
    public List<Channel> SearchByIdFather(Long idFather){
        List<Channel> list = channelRepo.findByIdFather(idFather);
        return list;
    }

    @Override
    public List<Channel> SearchByName(String name){
        if(name==null || name.isEmpty())
            return null;
        List<Channel> list = channelRepo.findByName(name);
        if(list==null)
            list = channelRepo.findByNameLike(name);
        return list;
    }

    @Override
    public Channel Insert(Channel channel){
        Channel c = channelRepo.save(channel);
        return c;
    }

    @Override
    public void Delete(Long id){
        channelRepo.delete(id);
    }

}
