package cn.efunbox.audio.repository;

import cn.efunbox.audio.vo.SearchVO;
import cn.efunbox.audio.entity.Audio;
import org.apache.commons.lang3.StringUtils;
import org.hibernate.SQLQuery;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;
import org.springframework.util.CollectionUtils;

import javax.persistence.EntityManager;
import javax.persistence.Query;
import java.math.BigInteger;
import java.util.List;
import java.util.Objects;


/**
 * AudioRepoImpl
 * Created by xusq on 2018/5/11.
 */
@Repository
public class AudioRepoImpl {

    @Autowired
    private EntityManager entityManager;

    public List<Audio> findAudio(SearchVO searchVO, Integer pageStart, int pageSize) {

        StringBuilder sb = new StringBuilder("select * from audio where 1=1 ");

        fillSql(searchVO,sb);

        Query query = entityManager.createNativeQuery(sb.toString());
        query.unwrap(SQLQuery.class).addEntity(Audio.class);
        query.setFirstResult(pageStart);
        query.setMaxResults(pageSize);

        return query.getResultList();
    }

    public Long count(SearchVO searchVO) {

        StringBuilder sb = new StringBuilder("select count(*) from audio where 1=1 ");

        fillSql(searchVO,sb);
        Query query = entityManager.createNativeQuery(sb.toString());
        BigInteger singleResult = (BigInteger)query.getSingleResult();

        return singleResult.longValue();
    }

    private void fillSql(SearchVO searchVO, StringBuilder sb) {

        if (StringUtils.isNotBlank(searchVO.getName())) {
            sb.append("and name like '%").append(searchVO.getName()).append("%'");
        }

        if (StringUtils.isNotBlank(searchVO.getKeyword())) {
            sb.append("and name like '%").append(searchVO.getKeyword()).append("%'");
        }

        List<BigInteger> idAlbums = searchVO.getIdAlbums();
        if (!CollectionUtils.isEmpty(idAlbums)) {
            sb.append("and album_id in (");
            for (int i = 0; i < idAlbums.size();i++) {
                if (i > 0) {
                    sb.append(",");
                }
                sb.append("'").append(idAlbums.get(i)).append("'");
            }
            sb.append(") ");
        }

        List<Long> idGroups = searchVO.getIdGroups();
        if (!CollectionUtils.isEmpty(idGroups)) {
            sb.append("and id_group in (");
            for (int i = 0; i < idGroups.size();i++) {
                if (i > 0) {
                    sb.append(",");
                }
                sb.append("'").append(idGroups.get(i)).append("'");
            }
            sb.append(") ");
        }

        if (Objects.nonNull(searchVO.getMediaType()) && searchVO.getMediaType() > 0) {
            sb.append("and media_type = ");
            sb.append( searchVO.getMediaType() );
        }

        if (Objects.nonNull(searchVO.getLesson()) && searchVO.getMediaType() > 0) {
            sb.append(" and lesson = ");
            sb.append( searchVO.getLesson() );
        }
    }
}
